Index: gs3-installations/intermuse/trunk/sites/intermuse/collect/programmes-and-performers/etc/collectionConfig.xml
===================================================================
--- gs3-installations/intermuse/trunk/sites/intermuse/collect/programmes-and-performers/etc/collectionConfig.xml	(revision 37156)
+++ gs3-installations/intermuse/trunk/sites/intermuse/collect/programmes-and-performers/etc/collectionConfig.xml	(revision 37166)
@@ -103,18 +103,71 @@
 	  -->
 			  <!--
-			<xsl:template name="document-link-mirador">
-			  <a>
-			    <xsl:attribute name="href"><xsl:value-of select="$library_name"/><xsl:text>/collection/</xsl:text><xsl:value-of select="/page/pageResponse/collection/@name"/><xsl:text>/document/</xsl:text><xsl:choose><xsl:when test="@OID"><xsl:value-of select="@OID"/></xsl:when><xsl:when test="@OIDmetadata"><xsl:variable name="OIDmeta" select="@OIDmetadata"/><xsl:value-of select="metadataList/metadata[@name='{$OIDmeta}']"/></xsl:when><xsl:otherwise><xsl:value-of select="@nodeID"/></xsl:otherwise></xsl:choose><xsl:text>?book=mirador&amp;ed=1</xsl:text></xsl:attribute>
-			    <gsf:icon type="document" style="vertical-align:middle;"/><xsl:call-template name="choose-title"/>
-			  </a>
-			</xsl:template>
-			  -->
-			  
-			  <!--
 			      modify the collection description template to output the "this collection contains X documents and was last built Y days ago" message
 			  -->
-			<xsl:template name="coll-description">
+			  <xsl:template name="coll-description">
+			    <p>
+			      
+			      Live musical events play a vital role in community life across the
+			      globe, yet their very âlivenessâ means they often leave only faint
+			      traces on the historical record, even in modern times. While
+			      musicologists have used some types of concert ephemera to capture the
+			      nature and identity of musical events, by there very nature these
+			      resources can be confusingly inconsistent, tantalisingly incomplete,
+			      and often scattered between different archives and collections.
+			    </p>
+
+			    <p>
+			      This (prototype) InterMusE Digital Library is a resource developed as the result
+			      of a two-year project, funded by AHRCâs UK-US New Directions for Digital
+			      Scholarship in Cultural Institutions programme, that seeks
+			      to better capture and represent these historical events.
+			      
+			      Using natural-language processing, optical character recognition (OCR),
+			      and other forms of artificial intelligence, this digital library 
+			      brings together an array of digitised resources sourced from:
+			      <ul>
+				<li>
+				  University of Yorkâs <a href="https://www.york.ac.uk/borthwick/" target="_blank" rel="noreferrer noopener">Borthwick Institute for Archives</a>,
+				</li>
+				<li>
+				  <a href="https://krannertcenter.com/" target="_blank" rel="noreferrer noopener">Krannert Center for the Performing Arts</a> (University of Illinois at Urbana-Champaign),
+				</li>
+				<li>
+				  <a href="https://linenhall.com/?gclid=CjwKCAiAmrOBBhA0EiwArn3mfAtN1-wdaaatezqK2X672WkKTS2he3g-8eDTZPc2INaYSHIdBQ4DExoCh-kQAvD_BwE" target="_blank" rel="noreferrer noopener">Linen Hall Library (Belfast</a>), and
+				</li>
+				<li>
+				  <a href="https://www.rcm.ac.uk/" target="_blank" rel="noreferrer noopener">Royal College of Music</a>.
+				</li>
+			      </ul>
+			      Material is also sourced from three former chapters of the British Music Society (est. 1918):
+			      <ul>
+				<li>
+				  <a href="http://www.huddersfield-music-society.org.uk/" target="_blank" rel="noreferrer noopener">Huddersfield Music Society</a>,
+				</li>
+				<li>
+				  <a href="http://www.bms-york.org.uk/" target="_blank" rel="noreferrer noopener">British Music Society of York</a>, and
+				</li>
+				<li>
+				  <a href="https://www.belfastmusicsociety.org/">Belfast Music Society</a>.
+				</li>
+			      </ul>
+			    </p>
+
+			    <p>
+			      Unifying these resources ... Linked Open Data ....
+
+			      More details are available through the
+			      <a href="https://intermuse.datatodata.org/" target="_blank">InterMuse project website</a>.
+			    </p>
+			      
+			    <p>
+			      Use the browsing and searching features the digital library provides to locate content
+			      of interest.  Register as a user  to become an annotator/editor of the content.
+			      As a developer seeking to enrich the forms of access to this content,
+			      a machine-readable version of the content is accessable through a
+			      <a href="{$library_name}/collection/{$collName}/page/sparql">SPARQL endpoint</a>
+			    </p>
 				<p>
-					<gslib:collectionDescriptionTextAndServicesLinks/>
+				  <gslib:collectionDescriptionTextAndServicesLinks/>
 				</p>
 				<xsl:variable name="raw_date">
@@ -128,5 +181,8 @@
 				</xsl:variable>
 				<p>
+				  This prototype collection contains <xsl:value-of select="$numdocs"/> documents.
+				  <!--
 					<xsl:value-of select="util:getInterfaceText($interface_name, /page/@lang, 'about.standarddescriptiondays', concat($numdocs, ';', $formatted_date))"/>
+				  -->
 				</p>
 			</xsl:template>
@@ -156,5 +212,5 @@
 			<displayItem lang="en" name="name">page</displayItem>
 		</level>
-		<defaultLevel name="document"/>
+		<defaultLevel name="section"/>
 		
 		<sort name="rank">
@@ -192,5 +248,5 @@
 			  </xsl:call-template>				  
 			</td>
-			<td>
+			<td valign="top" style="width: 100%"> <!-- causes this (final) table cell to autofill -->			  
 			  <xsl:call-template name="document-link-mirador-ahref">
 			    <xsl:with-param name="embed">
@@ -217,5 +273,5 @@
 			  </gsf:link>
 			</td>
-			<td valign="top">
+			<td valign="top" style="width: 100%"> <!-- causes this (final) table cell to autofill -->
 			  <gsf:link type="document">
 			    <xsl:call-template name="choose-title"/>
@@ -446,5 +502,4 @@
 		     <gsf:metadata name="HasGoogleVisionDocumentOCRJSON"/>
 		     <gsf:metadata name="GVDocumentOCRJSON"/>
-		     <gsf:metadata name="SASShortID"/>
 		     
 		     <gsf:metadata name="ex.im.No"/>
@@ -494,5 +549,7 @@
 				    **** currently needed to ensure ILT TOC gets Image (rather than Source) metadata ?????
 				-->
+				
 				<gsf:metadata hidden="true" name="im.Programme" select="root"/>
+				<gsf:metadata hidden="true" name="SASShortID" />
 				<gsf:metadata hidden="true" name="ex.im.GSFriendlyProg"/>
 				<gsf:metadata hidden="true" name="ex.im.GSFriendlyPage"/>