Index: gs3-installations/test-suite/trunk/sites/test-suite/collect/filelevel-docver/FILELEVEL-DOCVER-TEST-STEP1.sh
===================================================================
--- gs3-installations/test-suite/trunk/sites/test-suite/collect/filelevel-docver/FILELEVEL-DOCVER-TEST-STEP1.sh	(revision 37203)
+++ 	(revision )
@@ -1,69 +1,0 @@
-#!/bin/bash
-
-source ../_local_collect_config.bash
-
-echo ""
-
-echo "****"
-echo "Restoring import files back to original form"
-echo "... and Initiating full rebuild"
-echo "****"
-
-echo ""
-echo "Reverting 09_1_1.item back to its original form"
-/bin/cp testing-files/09_1_1.item import/09/09_1_1.item
-
-echo ""
-echo "Reverting Item 10_1_1 txt and img files back to original version:"
-
-echo "    import/10/text/10_1_1_1.txt"
-/bin/cp testing-files/10_1_1_1.txt import/10/text/10_1_1_1.txt
-
-echo "    import/10/images/10_1_1_1.gif"
-/bin/cp testing-files/10_1_1_1.gif import/10/images/10_1_1_1.gif
-echo ""
-
-if [ ! -d import/23 ] ; then
-    echo ""
-    echo "Restoring directory import/23"
-    /bin/cp -r testing-files/23 import/.
-fi
-
-if [ -d cached ] ; then
-    echo ""
-    echo "Removeing collection cache"
-    /bin/rm -rf cached
-fi
-
-./FULL-REBUILD.sh
-
-if [ $? = 0 ] ; then 
-    echo ""
-    echo "##############################################################################"
-    echo "##############################################################################"
-    echo "##############################################################################"
-    echo ""
-    
-    echo ""
-    echo "####"
-    echo "The collection has been reset and freshly rebuilt"
-    echo "####"
-    
-    echo ""
-    echo "# Test 1:"
-    echo "Access the collection's About Page in your browser through:"
-    echo "    $gs_library_url/collection/$col"
-    echo ""
-    echo "The  page should say that it contains 7 documents"
-    
-    echo ""
-    echo "# Test 2:"
-    echo "Access the collection's Browser by Title Classifier page (CL1):"
-    echo "    $gs_library_url/collection/$col/browse/CL1"
-    echo ""
-    echo "It should list all 7 documents"
-    echo ""
-    
-    echo "####"
-    echo ""
-fi
Index: gs3-installations/test-suite/trunk/sites/test-suite/collect/filelevel-docver/FILELEVEL-DOCVER-TEST-STEP2.sh
===================================================================
--- gs3-installations/test-suite/trunk/sites/test-suite/collect/filelevel-docver/FILELEVEL-DOCVER-TEST-STEP2.sh	(revision 37203)
+++ 	(revision )
@@ -1,64 +1,0 @@
-#!/bin/bash
-
-source ../_local_collect_config.bash
-
-echo ""
-echo "****"
-echo "Editing Title Metadata of : import/09/09_1_1.item "
-echo "****"
-/bin/cp testing-files/09_1_1--edited-title-metadata.item import/09/09_1_1.item
-
-echo ""
-echo "****"
-echo "Removing directory: import/23"
-echo "  which contains 23__1.item and 23__2.item"
-echo "****"
-
-/bin/rm -rf import/23
-
-
-echo ""
-echo "****"
-echo "Initiating incremental build with -keepold"
-echo " => Triggers file-level document-version history ONLY for newly processed content in 'archives'"
-echo "****"
-
-sleep 3
-
-incremental-import.pl -site $site -keepold $col \
-    && incremental-buildcol.pl -site $site -keepold -library_url $gs_library_url -activate $col
-
-
-## incremental-rebuild.pl -site $site -library_url $gs_library_url "$@" $col
-
-
-echo ""
-echo "##############################################################################"
-echo "##############################################################################"
-echo "##############################################################################"
-echo ""
-
-echo ""
-echo "####"
-echo "2 documents have been deleted (import/23/{23__1.item,23__2.item})"
-echo "1 document has had its title metadata edited (import/09/09_1_1.item)"
-echo "The collection has then been incrementall rebuilt"
-echo "####"
-
-# echo ""
-# echo "# Test 1:"
-# echo "Access the collection's About Page in your browser through:"
-# echo "    $gs_library_url/collection/$col"
-# echo ""
-# echo "The  page should say that it contains 7 documents"
-
-# echo ""
-# echo "# Test 2:"
-# echo "Access the collection's Browser by Title Classifier page (CL1):"
-# echo "    $gs_library_url/collection/$col/browse/CL1"
-# echo ""
-# echo "It should list all 7 documents"
-# echo ""
-
-echo "####"
-echo ""
Index: gs3-installations/test-suite/trunk/sites/test-suite/collect/filelevel-docver/FILELEVEL-DOCVER-TEST-STEP3.sh
===================================================================
--- gs3-installations/test-suite/trunk/sites/test-suite/collect/filelevel-docver/FILELEVEL-DOCVER-TEST-STEP3.sh	(revision 37203)
+++ 	(revision )
@@ -1,17 +1,0 @@
-#!/bin/bash
-
-source ../_local_collect_config.bash
-
-echo ""
-echo "****"
-echo "Initiating full rebuild with -keepold"
-echo "  => Triggers file-level document-verison history for ALL archive documents"
-echo "****"
-
-sleep 3
-
-
-import.pl -keepold -site $site "$@" $col \
-    && buildcol.pl -removeold -site $site $col \
-    && activate.pl -removeold -site $site -library_url $gs_library_url $col
-
Index: gs3-installations/test-suite/trunk/sites/test-suite/collect/filelevel-docver/TEST-STEP1-INGEST.sh
===================================================================
--- gs3-installations/test-suite/trunk/sites/test-suite/collect/filelevel-docver/TEST-STEP1-INGEST.sh	(revision 37205)
+++ gs3-installations/test-suite/trunk/sites/test-suite/collect/filelevel-docver/TEST-STEP1-INGEST.sh	(revision 37205)
@@ -0,0 +1,69 @@
+#!/bin/bash
+
+source ../_local_collect_config.bash
+
+echo ""
+
+echo "****"
+echo "Restoring import files back to original form"
+echo "... and Initiating full rebuild"
+echo "****"
+
+echo ""
+echo "Reverting 09_1_1.item back to its original form"
+/bin/cp testing-files/09_1_1.item import/09/09_1_1.item
+
+echo ""
+echo "Reverting Item 10_1_1 txt and img files back to original version:"
+
+echo "    import/10/text/10_1_1_1.txt"
+/bin/cp testing-files/10_1_1_1.txt import/10/text/10_1_1_1.txt
+
+echo "    import/10/images/10_1_1_1.gif"
+/bin/cp testing-files/10_1_1_1.gif import/10/images/10_1_1_1.gif
+echo ""
+
+if [ ! -d import/23 ] ; then
+    echo ""
+    echo "Restoring directory import/23"
+    /bin/cp -r testing-files/23 import/.
+fi
+
+if [ -d cached ] ; then
+    echo ""
+    echo "Removeing collection cache"
+    /bin/rm -rf cached
+fi
+
+./FULL-REBUILD.sh
+
+if [ $? = 0 ] ; then 
+    echo ""
+    echo "##############################################################################"
+    echo "##############################################################################"
+    echo "##############################################################################"
+    echo ""
+    
+    echo ""
+    echo "####"
+    echo "The collection has been reset and freshly rebuilt"
+    echo "####"
+    
+    echo ""
+    echo "# Test 1:"
+    echo "Access the collection's About Page in your browser through:"
+    echo "    $gs_library_url/collection/$col"
+    echo ""
+    echo "The  page should say that it contains 7 documents"
+    
+    echo ""
+    echo "# Test 2:"
+    echo "Access the collection's Browser by Title Classifier page (CL1):"
+    echo "    $gs_library_url/collection/$col/browse/CL1"
+    echo ""
+    echo "It should list all 7 documents"
+    echo ""
+    
+    echo "####"
+    echo ""
+fi
Index: gs3-installations/test-suite/trunk/sites/test-suite/collect/filelevel-docver/TEST-STEP2-GET-AND-SET-METADATA.sh
===================================================================
--- gs3-installations/test-suite/trunk/sites/test-suite/collect/filelevel-docver/TEST-STEP2-GET-AND-SET-METADATA.sh	(revision 37205)
+++ gs3-installations/test-suite/trunk/sites/test-suite/collect/filelevel-docver/TEST-STEP2-GET-AND-SET-METADATA.sh	(revision 37205)
@@ -0,0 +1,56 @@
+#!/bin/bash
+
+
+source ../_local_collect_config.bash
+
+doc_id="HASH01b058d81d87cbb75516422b"
+
+cd $GSDL3HOME/WEB-INF/cgi
+
+export REQUEST_METHOD=GET
+export QUERY_STRING="a=get-archives-metadata&site=test-suite&c=filelevel-docver&d=$doc_id&metaname=Title"
+
+
+
+echo "========"
+echo "Retrieving current Title metadata for $doc_id:"
+echo "--------"
+#./metadata-server.pl
+./metadata-server.pl 2> /dev/null
+echo ""
+echo "--------"
+echo ""
+
+export QUERY_STRING="a=get-archives-metadata&site=test-suite&c=filelevel-docver&d=$doc_id&metaname=Title&dv=nminus-1"
+
+echo "========"
+echo "Retrieving dv=nminus-1 Title metadata for $doc_id:"
+echo "--------"
+./metadata-server.pl 2> /dev/null
+echo ""
+echo "--------"
+echo ""
+
+
+export QUERY_STRING="a=set-archives-metadata&site=test-suite&c=filelevel-docver&d=$doc_id&metaname=Title&metavalue=Te%20Waka%20o%20Te%20Iwi%20EDITED%20EDITED&dv=nminus-1"
+export GS3_AUTHENTICATED=true
+
+echo "========"
+echo "Setting dv=nminus-1 Title metadata (EDITED EDITED) for $doc_id:"
+echo "--------"
+./metadata-server.pl 
+#./metadata-server.pl 2> /dev/null
+echo ""
+echo "--------"
+echo ""
+
+
+export QUERY_STRING="a=get-archives-metadata&site=test-suite&c=filelevel-docver&d=$doc_id&metaname=Title&dv=nminus-1"
+
+echo "========"
+echo "Retrieving dv=nminus-1 Title metadata for $doc_id:"
+echo "--------"
+./metadata-server.pl 2> /dev/null
+echo ""
+echo "--------"
+echo ""
Index: gs3-installations/test-suite/trunk/sites/test-suite/collect/filelevel-docver/TEST-STEP2-INGEST.sh
===================================================================
--- gs3-installations/test-suite/trunk/sites/test-suite/collect/filelevel-docver/TEST-STEP2-INGEST.sh	(revision 37205)
+++ gs3-installations/test-suite/trunk/sites/test-suite/collect/filelevel-docver/TEST-STEP2-INGEST.sh	(revision 37205)
@@ -0,0 +1,64 @@
+#!/bin/bash
+
+source ../_local_collect_config.bash
+
+echo ""
+echo "****"
+echo "Editing Title Metadata of : import/09/09_1_1.item "
+echo "****"
+/bin/cp testing-files/09_1_1--edited-title-metadata.item import/09/09_1_1.item
+
+echo ""
+echo "****"
+echo "Removing directory: import/23"
+echo "  which contains 23__1.item and 23__2.item"
+echo "****"
+
+/bin/rm -rf import/23
+
+
+echo ""
+echo "****"
+echo "Initiating incremental build with -keepold"
+echo " => Triggers file-level document-version history ONLY for newly processed content in 'archives'"
+echo "****"
+
+sleep 3
+
+incremental-import.pl -site $site -keepold $col \
+    && incremental-buildcol.pl -site $site -keepold -library_url $gs_library_url -activate $col
+
+
+## incremental-rebuild.pl -site $site -library_url $gs_library_url "$@" $col
+
+
+echo ""
+echo "##############################################################################"
+echo "##############################################################################"
+echo "##############################################################################"
+echo ""
+
+echo ""
+echo "####"
+echo "2 documents have been deleted (import/23/{23__1.item,23__2.item})"
+echo "1 document has had its title metadata edited (import/09/09_1_1.item)"
+echo "The collection has then been incrementall rebuilt"
+echo "####"
+
+# echo ""
+# echo "# Test 1:"
+# echo "Access the collection's About Page in your browser through:"
+# echo "    $gs_library_url/collection/$col"
+# echo ""
+# echo "The  page should say that it contains 7 documents"
+
+# echo ""
+# echo "# Test 2:"
+# echo "Access the collection's Browser by Title Classifier page (CL1):"
+# echo "    $gs_library_url/collection/$col/browse/CL1"
+# echo ""
+# echo "It should list all 7 documents"
+# echo ""
+
+echo "####"
+echo ""
Index: gs3-installations/test-suite/trunk/sites/test-suite/collect/filelevel-docver/TEST-STEP3-INGEST.sh
===================================================================
--- gs3-installations/test-suite/trunk/sites/test-suite/collect/filelevel-docver/TEST-STEP3-INGEST.sh	(revision 37205)
+++ gs3-installations/test-suite/trunk/sites/test-suite/collect/filelevel-docver/TEST-STEP3-INGEST.sh	(revision 37205)
@@ -0,0 +1,17 @@
+#!/bin/bash
+
+source ../_local_collect_config.bash
+
+echo ""
+echo "****"
+echo "Initiating full rebuild with -keepold"
+echo "  => Triggers file-level document-verison history for ALL archive documents"
+echo "****"
+
+sleep 3
+
+
+import.pl -keepold -site $site "$@" $col \
+    && buildcol.pl -removeold -site $site $col \
+    && activate.pl -removeold -site $site -library_url $gs_library_url $col
+